randomize();

x = 1191;
y = 1181;

height = 1080 / 4;
width  = (16/9) * height;
default_zoom = 11.48;
zoom = default_zoom;
zoom_target = zoom;
zoom_x_change = 0;
zoom_y_change = 0;
max_zoom = 16;
zoom_margin =  4.4;
grip_ctrl = false;

window_zoom = 4;
fullscreen = true;
window_set_fullscreen(fullscreen);

move_to_country = noone;
move_to_boom = noone;

depth = -10000;

grip_x = 0;
grip_y = 0;
grip_original_x = x;
grip_original_y = y;
gripping = false;

hover_mute = false;
hover_fullscreen = false;

camera = camera_create();
view_camera[0]  = camera;
view_visible[0] = true;
view_enabled    = true;

window_set_size(width * window_zoom, height * window_zoom);
surface_resize(application_surface, width * window_zoom, height * window_zoom);
display_set_gui_size(width * window_zoom, height * window_zoom);
camera_set_view_size(camera, width * zoom, height * zoom);
window_set_position(
	(display_get_width()  - width  * window_zoom) / 2,
	(display_get_height() - height * window_zoom) / 2
);

camera_set_view_pos(
	camera,
	x,
	y
);

bgm_gain = .5;
sound_on = true;
bgm = audio_play_sound(bgm_song_of_nukes, 150, true);
audio_sound_gain(bgm, bgm_gain, 0);

timer = floor(-room_speed * .6);

logo_bg_color = $3a2f2c;
credits_bg_color = $4f404e;

credits_timer = -1;
credits_text = [
	"Congratulations, you won!",
	"All countries with nukes have been destroyed.",
	"Click anywhere or press anything to follow me on twitter :)"
];

draw_set_font(fnt_good);

aiming_difficulty = 1;