
hover = false;
hover_triangle = undefined;

var _no_interact = keyboard_check(vk_control) || nuked || suspect || obj_world.mouse_locked || obj_camera.grip_ctrl;

// Check for hover
if (!_no_interact) {
	var _paths_count = array_length(paths);
	
	for (var _pathi = 0; _pathi < _paths_count; _pathi++) {
		var _path = paths[_pathi];
		var _vertices  = _path.verticies;
		var _triangles = _path.triangles;
	
		// Optimization
		if (point_in_rectangle(
			mouse_x,
			mouse_y,
		
			_path.left   * scale_x + offset_x,
			_path.top    * scale_y + offset_y,
			_path.right  * scale_x + offset_x,
			_path.bottom * scale_y + offset_y
		) < 1) { 
			continue;
		}
	
		// var _debug_color = c_white;
		// draw_rectangle(
		// 	_path.left   * scale_x + offset_x,
		// 	_path.top    * scale_y + offset_y,
		// 	_path.right  * scale_x + offset_x,
		// 	_path.bottom * scale_y + offset_y,
		// 	_debug_color
		// );
		
		var _triangles_len = array_length(_triangles);
		if (_triangles_len != 0) {
			for (var i = 0; i < _triangles_len; i += 3) {
				var _p = [
					_vertices[_triangles[i    ] * 2] * scale_x + offset_x, _vertices[_triangles[i    ] * 2 + 1] * scale_y + offset_y,
					_vertices[_triangles[i + 1] * 2] * scale_x + offset_x, _vertices[_triangles[i + 1] * 2 + 1] * scale_y + offset_y,
					_vertices[_triangles[i + 2] * 2] * scale_x + offset_x, _vertices[_triangles[i + 2] * 2 + 1] * scale_y + offset_y,
				];
			
				if (point_in_triangle(
					mouse_x,
					mouse_y,
					_p[0], _p[1],
					_p[2], _p[3],
					_p[4], _p[5]
				)) {
					hover = true;
					hover_path = _path;
					
					obj_debug_triangle.vertices = _p;
				}
			
				//draw_vertex_color(_vertices[_triangles[i    ] * 2] * scale_x + offset_x, _vertices[_triangles[i    ] * 2 + 1] * scale_y + offset_y, color, 1);
				//draw_vertex_color(_vertices[_triangles[i + 1] * 2] * scale_x + offset_x, _vertices[_triangles[i + 1] * 2 + 1] * scale_y + offset_y, color, 1);
				//draw_vertex_color(_vertices[_triangles[i + 2] * 2] * scale_x + offset_x, _vertices[_triangles[i + 2] * 2 + 1] * scale_y + offset_y, color, 1);
			}
		} else {
			// Assumed noise
			//var _vertices_len = array_length(_vertices);
			//draw_primitive_begin(pr_linestrip);
			//for (var i = 0; i < _vertices_len; i += 2) {
			//	draw_vertex(_vertices[i], _vertices[i + 1]);
			//}
			//draw_primitive_end();
			//
			//draw_circle(_vertices[0], _vertices[1], 16, true);
		}
	}
} else {
	hover = false;
	// aiming = false;
	
	depth = -8;
}

if (code == "JP" && _no_interact && mouse_check_button(mb_left)) {
	show_debug_message(
		"No interact possible causes: " +
		string(keyboard_check(vk_control)) + ", " +
		string(nuked) + ", " +
		string(suspect) +  ", " +
		string(obj_world.mouse_locked) +  ", " +
		string(obj_camera.grip_ctrl)
	);	
}

if (hover) {
	hover_timer++;
	
	obj_world.hover = true;
	
	depth = -12;
	
	if (mouse_check_button_pressed(mb_left)) {
		with (object_index) {
			pressing = false;
			aiming = false;
			aiming_timer = 0;
			from_x = 0;
			from_y = 0;
		}
		
		pressing = true;
		aiming = true;
		obj_world.mouse_locked = true;
		
		if (hover_path != undefined) {
			var _center = find_path_center(hover_path);
			from_x = _center[0] * scale_x + offset_x;
			from_y = _center[1] * scale_y + offset_y;
		}
		
		
		with (obj_nuke_control) {
			offset_y_target = 96 * 2;	
		}
	}
} else {
	hover_timer = 0;
}

if (pressing) {
	
	target_x = from_x - (mouse_x - from_x) * 2;
	target_y = from_y - (mouse_y - from_y) * 2;
	
	if (mouse_check_button_released(mb_left)) {
		pressing = false;
		if (nuke_control != noone) {
			instance_destroy(nuke_control);
		}
		nuke_control = instance_create_depth(0, 0, -4000, obj_nuke_control);
		nuke_control.from_country = id;
		obj_world.mouse_locked = false;
	}
}

if (aiming) {
	aiming_timer++;
	
	// if (aiming_timer % floor(room_speed * .4) == 0) {
	// 	var _snd = audio_play_sound(snd_kdd, 10, false);	
	// 	audio_sound_gain(_snd, .2, 0);
	// }
	
	depth = -14;
} else {
	if (nuke_control != noone) {
		//instance_destroy(nuke_control);
		nuke_control.offset_y_target = 96 * 2;
		nuke_control.die = true;
		nuke_control = noone;
	}
}

if (!hover && !aiming && !nuked) {
	depth = -10;	
}