
timer++;

if (timer >= time) {
	var _tx = target_x;
	var _ty = target_y;
	var _collision = false;
	var _target = noone;
	var _hit_suspect = false;
	with (obj_country) {
		if (check_collision(_tx, _ty)) {
			_collision = true;
			drawn = false;
			_hit_suspect = suspect;
			suspect = false;
			nuked = true;
			_target = id;
			if (id == other.from_country) points = 2000;
			obj_game.points += points * ((_hit_suspect) * 2 - 1);
			break;
		}
	}
	
	if (_collision) {
		with (instance_create_depth(target_x, target_y, depth, obj_boom)) {
			points = _target.points;
			points_neg = !_hit_suspect;
			player_made = true;
		}
		
		with (obj_world) {
			// Remove suspect from suspsects list because it's dead now
			var _sus_len = array_length(suspects);
			for (var i = 0; i < _sus_len; i++) {
				if (suspects[i] == _target) {
					array_delete(suspects, i, 1);
					break;
				}
			}
			
			// Remove country from remaining countries list because it's dead now
			var _rem_len = array_length(remaining_countries);
			for (var i = 0; i < _rem_len; i++) {
				if (remaining_countries[i] == _target) {
					array_delete(remaining_countries, i, 1);
					break;
				}
			}
			
			// Banenr message for hitting non-suspect
			if (!_hit_suspect) {
				banner_string = "You hit a non-suspect!";
				banner_timer = 1;
			}
			
			// Banenr message for hitting non-suspect
			if (_target == other.from_country) {
				banner_string = "You hit yourself! -2000 points";
				banner_timer = 1;
			}
		}
		
	} else {
		with (instance_create_depth(target_x, target_y, depth, obj_effect)) {
			sprite_index = spr_splash;
			destroy_after_animation = true;
		}
		
		with (obj_world) {
			banner_string = "You missed, " + array_random(other.idiot_words) + ".";
			if (random(1) < .08) {
				banner_string = "Do you know how much those cost?";
			}
			banner_timer = 1;
		}
	}
	
	instance_destroy();
}