
if (keyboard_check(ord(switch_key_left))) {
	switch_left_turn += 1 / room_speed;
	if (switch_left_turn > .25) {
		switch_left_turn = .25;
		if (!left_played && obj_camera.sound_on) {
			audio_play_sound(snd_kzhh, 60, false);	
			left_played = true;
		}
	}
} else {
	left_played = false;
	switch_left_turn -= 1.5 / room_speed;
	if (switch_left_turn < 0) {
		switch_left_turn = 0;	
	}
}

if (keyboard_check(ord(switch_key_right))) {
	switch_right_turn += 1 / room_speed;
	if (switch_right_turn > .25) {
		switch_right_turn = .25;
		if (!right_played && obj_camera.sound_on) {
			audio_play_sound(snd_kzhh, 60, false);
			right_played = true;
		}
	}
} else {
	switch_right_turn -= 1.5 / room_speed;
	right_played = false;
	if (switch_right_turn < 0) {
		switch_right_turn = 0;	
	}
}

launch_button_offset = lerp(launch_button_offset, (!(switch_right_turn > .2 && switch_left_turn > .2)) * launch_button_height, .1);

// fire!
if (!die && switch_right_turn > .2 && switch_left_turn > .2 && keyboard_check_pressed(vk_space)) {
	with (instance_create_depth(from_country.from_x, from_country.from_y, depth + 100, obj_nuke)) {
		target_x = other.from_country.target_x;
		target_y = other.from_country.target_y;
		from_country = other.from_country;
	}
	
	obj_camera.aiming_difficulty++;
	
	from_country.aiming = false;
	die = true;
	offset_y_target = 96 * 2;
}

y_offset = lerp(y_offset, offset_y_target, .1);

if (die && offset_y_target - y_offset < 2) {
	instance_destroy();
}