
var _width  = obj_camera.width  * obj_camera.window_zoom;
var _height = obj_camera.height * obj_camera.window_zoom;

var _string_h = string_height("ASDQWEASCAS");
var _pad_x = 16;
var _pad_y = 12;
	
var _w6 = 960; // previously _width * .6;
	
if (banner_timer) {
	var _start = room_speed;
	var _fade = room_speed;
	var _end = room_speed * 5;
	
	var _pos = power(min((banner_timer - _start) / _fade, 1), 2);
	var _neg = power(median((banner_timer - _end) / _fade, 0, 1), 2);
	var _frac = _pos - _neg;
	
	if (_frac > 0 && banner_timer > _start) {
		draw_set_font(fnt_smaller);
		_string_h = string_height("ASDQWEASCAS");
		var _string1_height = string_height_ext(banner_string, _string_h, _w6);
		var _string1_width  = string_width_ext( banner_string, _string_h, _w6);
		var _bg_color = $2c2221;
		draw_rectangle_color(
			_width / 2 - _string1_width / 2 - _pad_x + (_string1_width + _pad_x * 2) * _neg,
			_height / 6,
			_width / 2 - _string1_width / 2 - _pad_x + (_string1_width + _pad_x * 2) * _pos,
			_height / 6 + _string_h,
			_bg_color, _bg_color, _bg_color, _bg_color, 
			false
		);
		var _color = $f6f2f1;
		draw_set_halign(fa_center);
		draw_text_ext_color(
			_width / 2,
			_height / 6,
			banner_string,
			_string_h,
			_w6,
			_color, _color, _color, _color,
			_frac
		);
		draw_set_font(fnt_good);
		_string_h = string_height("ASDQWEASCAS");
		draw_set_halign(fa_left);
	}
}

if (space_hint_timer > 0 || space_hint_countdown > 0) {
	var _frac = min(space_hint_timer / space_hint_time, 1);
	if (space_hint_countdown > 0) _frac = (space_hint_countdown / space_hint_time);
	
	
	draw_set_halign(fa_center);
	draw_set_font(fnt_smaller);
	var _dk_color = $3a2f2c;
	var _dk_pad = 4;
	
	var _string1 = string(array_length(suspects)) + " suspects left  [Space]";
	var _string1_width  = string_width_ext( _string1, _string_h, _w6);
	var _string1_height = string_height_ext(_string1, _string_h, _w6);
	
	var _x = _width / 2;
	var _y = _height + _dk_pad - _string1_height * _frac;
	
	var _bg_color = $4f404e;
	draw_rectangle_color(
		_x - _string1_width / 2 - _pad_x - _dk_pad,
		_y - _dk_pad,
		_x + _string1_width / 2 + _pad_x + _dk_pad,
		_y + _string1_height + _dk_pad,
		_dk_color, _dk_color, _dk_color, _dk_color, 
		false
	);
	draw_rectangle_color(
		_x - _string1_width / 2 - _pad_x,
		_y,
		_x + _string1_width / 2 + _pad_x,
		_y + _string1_height,
		_bg_color, _bg_color, _bg_color, _bg_color, 
		false
	);
	draw_text_ext(_x, _y, _string1, _string_h, _w6);
	
	draw_set_font(fnt_good);
	draw_set_halign(fa_left);
}

if ((auto_nuke_timer || auto_nuke_menu_countdown || auto_nuke_menu_timer) && instance_exists(victim)) {
	
	var _name = victim.name;
	var _name_prefix = victim.name_prefix;
	if (string_length(_name_prefix) > 0) {
		_name = _name_prefix + " " + _name;
	}
	
	var _offystart = room_speed * 2;
	var _offytime = room_speed * .9;
	var _offset_y = power(max(1 - ((max(auto_nuke_timer, auto_nuke_menu_timer) - _offystart) / _offytime), 0), 3) * _height;
	
	if (auto_nuke_menu_countdown > 0) {
		_offset_y = power(max(((_offytime - auto_nuke_menu_countdown) / _offytime), 0), 3) * _height;
	}
	
	if (auto_nuke_timer > _offystart || auto_nuke_menu_countdown > 0 || auto_nuke_menu_timer > _offystart) {
		var _dk_color = $3a2f2c;
		draw_set_halign(fa_center);
		draw_set_color(c_white);
		var _x = _width / 2;
		var _y = _offset_y + _height / 7;
		var _string1 = _name + " has been nuked!";
		var _string1_width  = string_width_ext( _string1, _string_h, _w6);
		var _string1_height = string_height_ext(_string1, _string_h, _w6);
		var _bg_color = $4f404e;
		var _dk_pad = 4;
		draw_rectangle_color(
			_x - _w6 / 2 - _pad_x - _dk_pad,
			_y - _dk_pad,
			_x + _w6 / 2 + _pad_x + _dk_pad,
			_y + _string1_height + _dk_pad,
			_dk_color, _dk_color, _dk_color, _dk_color, 
			false
		);
		draw_rectangle_color(
			_x - _w6 / 2 - _pad_x,
			_y,
			_x + _w6 / 2 + _pad_x,
			_y + _string1_height,
			_bg_color, _bg_color, _bg_color, _bg_color, 
			false
		);
		draw_text_ext(_x, _y, _string1, _string_h, _w6);
	
	
		var _mx = device_mouse_x_to_gui(0) - escape_menu_visible * 100000;
		var _my = device_mouse_y_to_gui(0) - escape_menu_visible * 100000;
	
		draw_set_halign(fa_left);
		draw_set_color(c_white);
		draw_set_font(fnt_smaller);
		_x = (_width - _w6) / 2;
		_y += _string1_height + _pad_y * 3;
		var _string2 = "We suspect one of the following countries to be the culprit:\n";
		var _suspects_len = array_length(suspects);
		var _string2_width  = string_width_ext( _string2, _string_h, _w6);
		var _string2_height = string_height_ext(_string2, _string_h, _w6) + _string_h + _string_h * _suspects_len;
		draw_rectangle_color(
			_x - _pad_x - _dk_pad,
			_y - _pad_y - _dk_pad,
			_x + _w6 + _pad_x + _dk_pad,
			_y + _string2_height + _dk_pad,
			_dk_color, _dk_color, _dk_color, _dk_color, 
			false
		);
		draw_rectangle_color(
			_x - _pad_x,
			_y - _pad_y,
			_x + _w6 + _pad_x,
			_y + _string2_height,
			_bg_color, _bg_color, _bg_color, _bg_color, 
			false
		);
		draw_text_ext(_x, _y, _string2, _string_h, _w6);
		window_set_cursor(cr_default);
		var _hover_country = noone;
		var _widest = 0;
		for (var i = 0; i < _suspects_len; i++) {
			var _sw = string_width_ext("    * " + suspects[i].name, _string_h, _w6);
			if (_sw > _widest) _widest = _sw;
		}
		for (var i = 0; i < _suspects_len; i++) {
			var _hover = _mx >= _x && _mx <= _x + _w6 && _my >= _y + _string_h + _string_h * i && _my < _y + _string_h + _string_h * (i + 1);
			var _color = _hover ? c_aqua: $c7d7e8;
			if (_hover) _hover_country = suspects[i];
			draw_text_ext_color(_x, _y + _string_h + _string_h * i, "    * " + suspects[i].name, _string_h, _w6, _color, _color, _color, _color, 1);
			draw_text_ext_color(_x + _widest + _pad_x * 4, _y + _string_h + _string_h * i, suspects[i].code, _string_h, _w6, _color, _color, _color, _color, 1);
		}
		if (_hover_country != noone) window_set_cursor(cr_handpoint);
		draw_set_halign(fa_right);
		draw_text_ext(_x + _w6, _y + _string2_height - _string_h + _pad_y, "Press any button to continue...", _string_h, _w6);
		draw_set_font(fnt_good);
	
		if (!escape_menu_visible && mouse_check_button_pressed(mb_left) && _hover_country != noone) {
			obj_camera.move_to_country = _hover_country;
			obj_camera.move_to_boom = noone;
			with (obj_boom) {
				player_made = true;	
			}
			auto_nuke_menu_countdown = room_speed * 1;
			auto_nuke_menu_countdown_fast = true;
			auto_nuke_menu_timer = 0;
			mouse_locked = false;
		}
	
	
	
		draw_set_halign(fa_left);
	}
}

function draw_text_rect(_x, _y, _string, _txt_color, _txt_hover_color, _bg_color, _bg_hover_color, _bg_alpha, _bg_pad_x) {
	var _text_width  = string_width( _string);
	var _text_height = string_height(_string);
	var _halign = draw_get_halign() / 2;
	
	var _hover = point_in_rectangle(
		device_mouse_x_to_gui(0),
		device_mouse_y_to_gui(0),
		_x - _text_width * _halign - _bg_pad_x, 
		_y, 
		_x + _text_width * (1 - _halign) + _bg_pad_x, 
		_y + _text_height
	);
	
	draw_set_color(_hover ? _bg_hover_color : _bg_color);
	draw_set_alpha(_bg_alpha);
	draw_rectangle(_x - _text_width * _halign - _bg_pad_x, _y, _x + _text_width * (1 - _halign) + _bg_pad_x, _y + _text_height, false);
	draw_set_color(_hover ? _txt_hover_color : _txt_color);
	draw_set_alpha(1);
	draw_text(_x, _y, _string);
	draw_set_color(c_white);
	
	return _hover;
}

if (escape_menu_visible) {
	draw_set_alpha(.5);
	draw_set_color(c_black);
	draw_rectangle(0, 0, _width, _height, false);	
	draw_set_alpha(1);
	draw_set_color(c_white);
	
	var _pad = 34;
	var _pad_x = 12;
	var _bg_hover_color = $493b37;
	var _really = escape_menu_visible_actual_message ? " REALLY" : "";
	
	draw_set_halign(fa_center);
	draw_text_rect(_width / 2, _height / 2 - 60, "Are you" + _really + " sure you want to quit?", c_white, c_white, $2c2221, $2c2221, 1, _pad_x);
	
	draw_set_font(fnt_smaller);
	draw_set_halign(fa_right);
	var _hover_yes = draw_text_rect(_width / 2 - _pad, _height / 2 + 60, "Yes", c_white, c_aqua, $2c2221, _bg_hover_color, 1, _pad_x);
	
	
	draw_set_halign(fa_center);
	draw_text(_width / 2, _height / 2 + 60, "/");
	
	draw_set_halign(fa_left);
	var _hover_no = draw_text_rect(_width / 2 + _pad, _height / 2 + 60, "No", c_white, c_aqua, $2c2221, _bg_hover_color, 1, _pad_x);
	
	if (escape_menu_visible_actual_message) {
		draw_set_halign(fa_center);
		draw_text_rect(_width / 2, _height / 2 + 60 + 120, "Press DELETE to actually quit", c_white, c_white, $2c2221, $2c2221, 1, _pad_x);
	}
	
	draw_set_font(fnt_good);
	window_set_cursor(cr_default);
	if (_hover_yes || _hover_no) {
		window_set_cursor(cr_handpoint);
		
		if (mouse_check_button_pressed(mb_left)) {
			if (_hover_yes) {
				url_open("https://www.youtube.com/watch?v=KxGRhd_iWuE");	
				escape_menu_visible_actual_message = true;
			}
			
			if (_hover_no) {
				toggle_menu();	
			}
		}
	}
}